package models

import (
	"eta/eta_task/global"
	"eta/eta_task/utils"
	"time"
)

type Classify struct {
	Id             int       `gorm:"column:id;primaryKey;autoIncrement"`
	ClassifyName   string    `description:"分类名称"`
	Sort           int       `json:"-"`
	ParentId       int       `description:"父级分类id"`
	CreateTime     time.Time `description:"创建时间"`
	ModifyTime     time.Time `description:"修改时间"`
	Abstract       string    `description:"栏目简介"`
	Descript       string    `description:"分享描述"`
	ReportAuthor   string    `description:"栏目作者"`
	AuthorDescript string    `description:"作者简介"`
	ColumnImgUrl   string    `description:"栏目配图"`
	HeadImgUrl     string    `description:"头部banner"`
	AvatarImgUrl   string    `description:"头像"`
	ReportImgUrl   string    `description:"报告配图"`
	HomeImgUrl     string    `description:"首页配图"`
	ClassifyLabel  string    `description:"分类标签"`
	IsMassSend     int       `description:"1:群发,0:非群发"`
}

func GetClassifyById(classifyId int) (item *Classify, err error) {
	sql := `SELECT * FROM classify WHERE id=? `
	o := global.DbMap[utils.DbNameReport]
	err = o.Raw(sql, classifyId).First(&item).Error
	return
}
