package cross_variety

import (
	"eta/eta_task/global"
	"eta/eta_task/utils"
	"time"
)

// ChartTagVariety
// @Description: chart_tag_variety 图表标签品种关系表
type ChartTagVariety struct {
	Id                        int       `gorm:"column:id;primaryKey;autoIncrement"`
	ChartTagId                int       `description:"标签id"`
	ChartVarietyId            int       `description:"品种id"`
	EdbInfoId                 int       `description:"指标id"`
	LastUpdateSysUserId       int       `description:"最后一次操作人"`
	LastUpdateSysUserRealName string    `description:"最后一次操作人真实姓名"`
	ModifyTime                time.Time `description:"修改时间"`
	CreateTime                time.Time `description:"创建时间"`
}

func GetChartTagVarietyEdbInfoIdsByTagIds(chartTagIds []int) (items []*ChartTagVariety, err error) {
	o := global.DbMap[utils.DbNameIndex]
	sql := `SELECT * FROM chart_tag_variety WHERE chart_tag_id in (` + utils.GetOrmInReplace(len(chartTagIds)) + `)`
	err = o.Raw(sql, chartTagIds).Find(&items).Error
	return
}
