package future_good

import (
	"eta/eta_task/global"
	"eta/eta_task/utils"
	"fmt"
	"strings"
	"time"
)

// ChartInfoFutureGoodProfit 商品利润图表-扩展信息
type ChartInfoFutureGoodProfit struct {
	ChartInfoId  int       `gorm:"column:chart_info_id;primaryKey;autoIncrement" description:"商品利润图表ID(chart_info表source=5的)"`
	ProfitName   string    `description:"利润名称"`
	ProfitNameEn string    `description:"利润英文名称"`
	XValue       string    `gorm:"column:x_value" description:"X轴数据值"`
	YValue       string    `gorm:"column:y_value" description:"Y轴数据值"`
	CreateTime   time.Time `description:"创建时间"`
	ModifyTime   time.Time `description:"更新时间"`
}

func (m *ChartInfoFutureGoodProfit) TableName() string {
	return "chart_info_future_good_profit"
}

func (m *ChartInfoFutureGoodProfit) Create() (err error) {
	err = global.DbMap[utils.DbNameIndex].Create(m).Error
	return
}

func (m *ChartInfoFutureGoodProfit) Update(cols []string) (err error) {
	err = global.DbMap[utils.DbNameIndex].Select(cols).Updates(m).Error
	return
}

func (m *ChartInfoFutureGoodProfit) Delete() (err error) {
	o := global.DbMap[utils.DbNameIndex]
	sql := fmt.Sprintf(`DELETE FROM %s WHERE chart_info_id = ? LIMIT 1`, m.TableName())
	err = o.Exec(sql, m.ChartInfoId).Error
	return
}

func (m *ChartInfoFutureGoodProfit) GetItemById(id int) (err error) {
	o := global.DbMap[utils.DbNameIndex]
	sql := fmt.Sprintf(`SELECT * FROM %s WHERE chart_info_id = ? LIMIT 1`, m.TableName())
	err = o.Raw(sql, id).First(&m).Error
	return
}

func (m *ChartInfoFutureGoodProfit) GetItemByCondition(condition string, pars []interface{}) (err error) {
	o := global.DbMap[utils.DbNameIndex]
	sql := fmt.Sprintf(`SELECT * FROM %s WHERE 1=1 %s LIMIT 1`, m.TableName(), condition)
	err = o.Raw(sql, pars...).First(&m).Error
	return
}

func (m *ChartInfoFutureGoodProfit) GetItemsByCondition(condition string, pars []interface{}, fieldArr []string, orderRule string) (items []*ChartInfoFutureGoodProfit, err error) {
	o := global.DbMap[utils.DbNameIndex]
	fields := strings.Join(fieldArr, ",")
	if len(fieldArr) == 0 {
		fields = `*`
	}
	order := ``
	if orderRule != "" {
		order = ` ORDER BY ` + orderRule
	}
	sql := fmt.Sprintf(`SELECT %s FROM %s WHERE 1=1 %s %s`, fields, m.TableName(), condition, order)
	err = o.Raw(sql, pars...).Find(&items).Error
	return
}
